#include "pch.h"

#include "CLI.Lib.h"

#include "Native.h"

using namespace VMProtect;


namespace CLI {
	namespace Lib
	{
		int Testor::Add(int a, int b)
		{
			return a + b;
		}

		[VMProtect::BeginUltra]
		UIntPtr^ Testor::OpenProcessCLI(DWORD pid)
		{
		
			return  gcnew UIntPtr(Native::VMPOpenProcess(pid));
		}


		[VMProtect::BeginUltra]
		void Testor::CloseHandleCLI(UIntPtr handle)
		{

			Native::VMPCloseHandle(handle.ToPointer());

		}




		void Testor::TestAction(Action<String^>^ action)
		{

			for (int i = 0; i < 10; ++i)
			{
				action(String::Format("Index{0}", i));
			}

		}


	}
}
